/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.workflow.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.common.utils.TimeUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.action.MosPWorkflowAction;
import jp.mosp.kintai.common.part.KintaiApprovalPart;
import jp.mosp.kintai.common.part.KintaiCommonPart;
import jp.mosp.kintai.kintai.dto.MSyukkinboDto;
import jp.mosp.kintai.workflow.dto.CtOvertimeRequestDto;
import jp.mosp.kintai.workflow.vo.ApprovalCardVo;

/**
 * @author yoshida
 *
 */
public class ApprovalCardAction extends MosPWorkflowAction {
	
	// コマンド
	private static final String	CMD_APPROVAL_CARD_SELECT	= "K2126";
	private static final String	CMD_APPROVAL_CARD_REGIST	= "K2127";
	private static final String	CMD_APPROVAL_CARD_RETURN	= "K2129";
	

	/**
	 * コンストラクタ
	 */
	public ApprovalCardAction() {
		super();
	}
	
	public void action() throws Exception {
		// VOの取得
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_APPROVAL_CARD_SELECT)) {
			// 選択
			select();
		} else if (cmd.equals(CMD_APPROVAL_CARD_REGIST)) {
			// 承認
			approved();
		} else if (cmd.equals(CMD_APPROVAL_CARD_RETURN)) {
			// 差戻
			returned();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new ApprovalCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// MANAGER権限確認
		confirmManagerAuth();
		ApprovalCardVo vo = (ApprovalCardVo)getVo();
		// ユーザー情報取得
		getInfo(user.getUserId());
		// 手当一覧
		vo.setAryAllowance(getMosPCodeArray(CommonConst.TID_ALLOWANCE_NAME));
	}
	
	/**
	 * 勤怠承認対象日取得
	 * @throws Exception	例外処理が発生した場合
	 */
	@Override
	protected void select() throws Exception {
		ApprovalCardVo vo = (ApprovalCardVo)getVo();
		vo.setParams(request);
		vo.setHidKCode(key1);
		vo.setHidDate(key2);
		// 承認対象情報設定
		setAttendanceInfo(kintai().getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate()));
	}
	
	/**
	 * 勤怠承認処理
	 * @throws Exception	例外処理が発生した場合
	 */
	private void approved() throws Exception {
		// DTOの取得
		MSyukkinboDto dto = (MSyukkinboDto)getSessionDto();
		ApprovalCardVo vo = (ApprovalCardVo)getVo();
		vo.setParams(request);
		// 排他確認
		chkExclusive(dto, kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke(), true));
		// DTOの再取得
		MSyukkinboDto retDto = dto;
		// 承認処理
		if (runDailyApprovalProcess(dto.getKCode(), DateUtil.convStringDateToDate(dto.getHizuke()), "", true)) {
			// コミット
			commit();
			// DTOの再取得
			retDto = kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke());
			chkUpdate(retDto);
			// メッセージ設定
			if (KintaiApprovalPart.is1stApproved(retDto)) {
				setMessage(getMessage(CommonConst.MSG_DONE, CommonConst.NAM_1ST_APPROVED));
			}
			if (KintaiApprovalPart.is2ndApproved(retDto)) {
				setMessage(getMessage(CommonConst.MSG_DONE, CommonConst.NAM_2ND_APPROVED));
			}
		}
		// モード設定
		setAttendanceInfo(retDto);
	}
	
	/**
	 * 勤怠差戻処理
	 * @throws Exception	例外処理が発生した場合
	 */
	private void returned() throws Exception {
		// DTOの取得
		MSyukkinboDto dto = (MSyukkinboDto)getSessionDto();
		ApprovalCardVo vo = (ApprovalCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// 排他確認
		chkExclusive(dto, kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke(), true));
		// DTOの再取得
		MSyukkinboDto retDto = dto;
		// 差戻処理
		if (runDailyApprovalProcess(dto.getKCode(), DateUtil.convStringDateToDate(dto.getHizuke()), vo.getTxtComment(),
				false)) {
			// コミット
			commit();
			// メッセージ設定
			setMessage(getMessage(CommonConst.MSG_APPROVAL_RETURNED, ""));
			// DTOの再取得
			retDto = kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke());
			chkUpdate(retDto);
		}
		// モード設定
		setAttendanceInfo(retDto);
	}
	
	/**
	 * 承認対象情報設定
	 * @param dto	対象DTO
	 * @throws Exception	例外処理が発生した場合
	 */
	private void setAttendanceInfo(MSyukkinboDto dto) throws Exception {
		ApprovalCardVo vo = (ApprovalCardVo)getVo();
		String kCode;
		Date targetDate;
		String statusCode = "";
		MSyukkinboDto retDto = null;
		// モード設定
		vo.setMode(ApprovalCardVo.MODE_VIEW);
		if (!KintaiApprovalPart.isDraft(dto) && VariousUtil.isNotNull(dto)) {
			retDto = dto;
			kCode = retDto.getKCode();
			targetDate = DateUtil.convStringDateToDate(retDto.getHizuke());
			vo.setHidKCode(kCode);
			vo.setHidDate(retDto.getHizuke());
			statusCode = retDto.getSnRiyuu();
			// 承認者確認
			if (part().kintaiApproval().isApprover(kCode, userBasis.getKCode(), statusCode, targetDate)) {
				vo.setMode(ApprovalCardVo.MODE_APPROVAL);
			}
		} else {
			kCode = vo.getHidKCode();
			targetDate = DateUtil.convStringDateToDate(vo.getHidDate());
			retDto = KintaiCommonPart.createBaseSyukkinboInfo(kCode, targetDate);
		}
		// 名称の変換
		kintai().replaceCodeToName(retDto);
		// VOに情報をセット
		vo.setFields(retDto);
		vo.setLblDate(DateUtil.convDateToFormatDateJP(targetDate));
		vo.setLblStatus(getApprovalName(statusCode));
		// 人事基本情報取得
		setLabelBasisInfo(kCode);
		// 労使協定情報設定
		setLaborAgreementInfo(kCode, targetDate);
		// 時間外警告対応
		vo.setCaution(checkCautionOverTimeMonthly(kCode, targetDate));
		// 月60時間時間外警告対応
		vo.setWarning(checkWarningOverTimeMonthly(kCode, targetDate));
		// 休暇申請
		vo.setAryLblHolidayRequest(getLabelHolidayRequestStatusArray(kCode, targetDate));
		// 残業申請
		CtOvertimeRequestDto overtimeDto = getOverTimeRequest(kCode, targetDate);
		if (VariousUtil.isNotNull(overtimeDto)) {
			StringBuffer sb = new StringBuffer();
			statusCode = toKintaiApprovalStatus(overtimeDto.getWorkflow());
			// 下書き以外
			if (!KintaiApprovalPart.isDraft(statusCode)) {
				// 申請時間
				sb.append(TimeUtil.convIntegerTimeToJPHours(overtimeDto.getOverTime()));
				// 承認状況
				sb.append(StringUtil.surroundBracket(getApprovalName(statusCode)));
				vo.setLblOverTimeRequest(sb.toString());
			}
		}
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
}
